﻿<%@ OutputCache Duration="864000" VaryByHeader="Host" VaryByParam="none" Location="any"%>
<%@ Page language="JScript" %>
<%@ Import Namespace="CardioLog.API" %>
<%
	Response.ContentType = "text/x-component";
%>
<html xmlns:CARDIOLOG>
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8">
	<PUBLIC:COMPONENT tagName=SCHEDULER>
		<PUBLIC:ATTACH event="oncontentready" onevent="init()"/>
		<PUBLIC:METHOD name="register"/>
		<PUBLIC:METHOD name="unregister"/>
		<PUBLIC:METHOD name="schedule"/>
		<PUBLIC:METHOD name="getData"/>
		<PUBLIC:METHOD name="getPrefs"/>
		<PUBLIC:METHOD name="setPrefs"/>
		
		<PUBLIC:METHOD name="setDebugMode"/>
		<PUBLIC:METHOD name="getDataOnce"/>
		<PUBLIC:METHOD name="getExportOnce"/>
		<PUBLIC:METHOD name="getViewers"/>
		<PUBLIC:METHOD name="redrawGraph"/>
		<PUBLIC:METHOD name="getHelpById"/>
		<PUBLIC:METHOD name="updatePreferences"/>
		<PUBLIC:METHOD name="openPreferences"/>
		<PUBLIC:METHOD name="Export"/>
		
		<PUBLIC:METHOD name="setPreferences"/>
		<PUBLIC:METHOD name="refresh"/>
		<PUBLIC:METHOD name="refreshAll"/>
		<PUBLIC:METHOD name="setChartType"/>
		<PUBLIC:METHOD name="getDimensions"/>
		
        <PUBLIC:METHOD name="isWaiting" />

		<PUBLIC:METHOD name="hasControls" />
		<PUBLIC:METHOD name="getPropertyByName"/>
		<PUBLIC:METHOD name="setProperties"/>
		
		<PUBLIC:PROPERTY name="silent"/>
		<PUBLIC:PROPERTY name="ignoreQuery"/>
		<PUBLIC:PROPERTY name="debudMode"/>
		<PUBLIC:PROPERTY name="htmlPath"/>
		
		<PUBLIC:PROPERTY name="callSpecificViewer"></PUBLIC:PROPERTY>
		<PUBLIC:PROPERTY name="retrieveTemplates"></PUBLIC:PROPERTY>
		<PUBLIC:PROPERTY name="retrieveTemplatesByUser"></PUBLIC:PROPERTY>
		<PUBLIC:PROPERTY name="retrieveTemplatesByCategory"></PUBLIC:PROPERTY>
        <PUBLIC:PROPERTY name="retrieveTemplatesForSEOStatusCode"></PUBLIC:PROPERTY>
        <PUBLIC:PROPERTY name="retrieveTemplatesForSEOPages"></PUBLIC:PROPERTY>
        
	</PUBLIC:COMPONENT>
	<script language="JScript">

		element.schedulerInterval = false;

		element.xmls = new Array();

		function getTransport() {
			var xml = new ActiveXObject("Microsoft.XMLHTTP");
			for (var i = element.xmls.length - 1; i >= 0; i--) {
				if (element.xmls[i].readyState == 4) {
					element.xmls[i] = null;
					delete element.xmls[i];
					element.xmls.length -= 1;
				}
			}
			element.xmls.push(xml);
			return xml;
		}

		var path;
		var debugMode;
		var method;

		function getViewers() {
			return element.viewers;
		}

		function getDimensions(id) {
			return element.viewers[id].obj.getDimensions();
		}

		function parseData(xml) {
			if (xml.readyState == 4) {
				element.oncall = false;
				if (element.pleaseWaitMessage) {
					closePleaseWaitMessage();
				}
				if (xml.status == 200 && xml.responseXML.parseError.errorCode == 0) {
					print("<textarea style='width:100%; height:100px;'>" + xml.responseXML.xml + "</textarea>");
					try {
						top.setLastRefereshed(new Date());
					} catch (e) {
						window.status = "Last refreshed:" + new Date();
					}
					var calls = xml.responseXML.selectNodes(".//call");
					for (var i = 0; i < calls.length; i++) {
						try {
							var viewer = element.viewers[calls[i].getAttribute("controlId")];
							var action = calls[i].getAttribute("action");
							var cached = calls[i].getAttribute("cached");
							if (viewer) {
								if (action == "temporary") {
									print("got temporary call for " + viewer.id);
									if (typeof (viewer.temporaryCallback) != "undefined") viewer.temporaryCallback(calls[i], cached);
									else viewer.callback(calls[i], cached);
								} else {
									viewer.lastCall = new Date();
									print("lastCall was updated for " + viewer.id);
									viewer.currentData = calls[i];
									viewer.callback(calls[i], (cached == "True") ? true : false);
									if (viewer.obj) viewer.obj.setCached(cached);
								}
							}
							else print("Unknown viewer #" + calls[i].getAttribute("controlId"));
						} catch (e) {
							print("Unknown error in viewer #" + e.description);
						}
					}
				} else {
					print("<%=CardioLog.API.Localization.getText("$error loading data from server$")%>:" + ((xml.status == 200) ? xml.responseXML.parseError.reason : xml.status));
					for (var i in element.viewers) {
						if (element.viewers[i] != null) element.viewers[i].lastCall = new Date();
					}
					element.pleaseWaitMessage = createErrorMessage("<%=CardioLog.API.Localization.getText("$error loading data from server$")%>");
				}
				schedule();
			}
		}
		function init() {
			defaults.viewLink = document;
			defaults.viewInheritStyle = false;

			debugMode = (element.debugMode) ? element.debugMode : false;
			path = (element.path) ? element.path : "";
			method = (element.method) ? element.method : "POST";

			element.htmlPath = (element.htmlPath) ? element.htmlPath : "/CardioLog/";
			if (debugMode && debugMode == "true") {
				setDebugMode(true);
			}
		}

		function unregister(cid) {
			if (cid == -1) {
				for (var i in element.viewers) {
					if (element.viewers[i] != null && element.viewers[i].type == "Meter") element.viewers[i] = null;
				}
			} else if (element.viewers[cid]) element.viewers[cid] = null;
			schedule();
		}
		function register(cid, prefs, freq, callback, type, obj, meta, width, height) {
			element.silent = false;
			element.viewers[cid] = new Viewer(cid, prefs, freq, callback, type, obj, meta, width, height);
			//			schedule();
		}

		function updatePreferences(id, names, values) {
			var prefs = element.viewers[id].prefs;
			for (var i = 0; i < names.length; i++) {
				prefs = setProperty(prefs, names[i], values[i]);
			}
			return prefs;
		}
		function getHelpById(viewerId) {
			var rs = "";
			for (var i in element.viewers[viewerId]) rs += i + ":" + element.viewers[viewerId][i] + "\n";
			//			alert(rs);

		}
		function excludeURL(string) {
			var finalString = string;
			var prefurl = /\<entityurl\>(.[^<]+)\<\/entityurl'?\>/gi;
			var re = string.match(prefurl);
			if (re != null && re.length > 0) {
				for (var i = 0; i < re.length; i++) {
					var fixedPrefUrl = re[i].toString().replace(/'/g, "");
					finalString = finalString.replace(re[i], fixedPrefUrl);
				}

			}

			var prefname = /\<entityname\>(.[^<]+)\<\/entityname'?\>/gi;
			var re = string.match(prefname);
			if (re != null && re.length > 0) {
				for (var i = 0; i < re.length; i++) {
					var fixedPrefName = re[i].toString().replace(/'/g, "");
					finalString = finalString.replace(re[i], fixedPrefName);
				}
			}
			return finalString;
		}
		function getPrefs(viewerId) {
			var prefs = element.viewers[viewerId].prefs.replace(/([0-9a-zא-ת]+)=([0-9a-zא-ת]+)/gi, "$1='$2'").replace(/([0-9a-zא-ת ]+)=\"([0-9a-zא-ת ]+)\"/gi, "$1='$2'");
			var finalPrefs = excludeURL(prefs);
			return finalPrefs;
		}

		function setChartType(id, chartType) {
			element.viewers[id].obj.changeChartType(chartType);
		}

		function getRecommendedTimeInterval(timeframe, viewer) {
			if (viewer.type == "DundasChart") {
				switch (Math.abs(timeframe) + "") {
					case "600000000":
					case "36000000000":
						return 36000000000;
					case "864000000000":
						return 864000000000;
					case "6048000000000":
						return 6048000000000;
					case "25920000000000":
						return 25920000000000;
					case "77760000000000":
						return 25920000000000;
				}
			} else {
				return Math.abs(timeframe);
			}
		}
		function parsePossibleTemplates(xml) {
			if (xml.readyState == 4) {
				var templates = new Array();
				var validString = xml.responseXml.text.replace(/&amp;/g, '&');
				var pairs = validString.split(";");

				for (var i = 0; i < pairs.length; i++) {
					if (pairs[i] == "") continue;
					var template = {};
					pairs[i].replace(/\'([^\']*)\',\'([^\']*)\'/, function (a, b, c) {
						template.name = encodeURIComponent(c);
						template.id = b;
					});
					templates.push(template);
				}

				if (ddCallback) ddCallback(templates);
			}
		}

		var ddXml = null;
		var ddCallback = null;
		function retrieveTemplatesByUser(user, callback) {
			ddCallback = callback;
			print("<%=CardioLog.API.Localization.getText("$Retrieving templates for user$")%>: " + user);
		    var path = "/cardiolog/CLReport/ContextBasedReportWS.asmx/getPublishedTemplatesForUser"
		    print(path);
		    if (ddXml == null) ddXml = getTransport();
		    ddXml.Open("POST", path, true);
		    ddXml.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		    ddXml.onreadystatechange = function () { parsePossibleTemplates(ddXml) };
		    ddXml.Send();
		}
		function retrieveTemplatesByCategory(category, callback) {
			ddCallback = callback;
			print("<%=CardioLog.API.Localization.getText("$Retrieving templates$")%>");
		    var path = "/cardiolog/CLReport/ContextBasedReportWS.asmx/getPublishedTemplatesForCategory"
		    print(path);
		    if (ddXml == null) ddXml = getTransport();
		    ddXml.Open("POST", path, true);
		    ddXml.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		    ddXml.onreadystatechange = function () { parsePossibleTemplates(ddXml) };
		    ddXml.Send();
		}
		function retrieveTemplates(url, callback) {
			ddCallback = callback;
			print("<%=CardioLog.API.Localization.getText("$Retrieving templates for url$")%>: " + url);
		    var path = "/cardiolog/CLReport/ContextBasedReportWS.asmx/getPublishedTemplatesByUrl"
		    print(path + "?" + url);
		    if (ddXml == null) ddXml = getTransport();
		    ddXml.Open("POST", path, true);
		    ddXml.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		    ddXml.onreadystatechange = function () { parsePossibleTemplates(ddXml) };
		    ddXml.Send("url=" + escape(url));
		}
		function retrieveTemplatesForSEOStatusCode(statusCode, callback) {
			ddCallback = callback;
			var path = "/cardiolog/CLReport/ContextBasedReportWS.asmx/getPublishedTemplatesForSEOStatusCode"
			var ddXml = new ActiveXObject("Microsoft.XMLHTTP");
			ddXml.Open("POST", path, true);
			ddXml.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			ddXml.onreadystatechange = function () { parsePossibleTemplates(ddXml) };
			ddXml.Send("statuscode=" + statusCode);
		}
		function retrieveTemplatesForSEOPages(pageUrl, callback) {
			ddCallback = callback;
			var path = "/cardiolog/CLReport/ContextBasedReportWS.asmx/getPublishedTemplatesForSEOPages"
			var ddXml = new ActiveXObject("Microsoft.XMLHTTP");
			ddXml.Open("POST", path, true);
			ddXml.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			ddXml.onreadystatechange = function () { parsePossibleTemplates(ddXml) };
			ddXml.Send("pageUrl=" + pageUrl);
		}
		function setProperties(props) {
			for (var v in element.viewers) {
				if (element.viewers[v] != null) {
					element.viewers[v].originalPrefs = {
						timeframe: getProperty(element.viewers[v].prefs, "timeframe", "static"),
						timeinterval: getProperty(element.viewers[v].prefs, "timeinterval", "static")
					};
				}
			}

			for (var i = 0; i < props.length; i++) {
				for (var v in element.viewers) {
					if (element.viewers[v] != null) {
						var isSourceBase = (getProperty(element.viewers[v].prefs, "entityid", "") != "static");
						if (isSourceBase && props[i].name == "entityUrl") continue;
						if (!isSourceBase && (props[i].name == "entityId" || props[i].name == "entityName" || props[i].name == "entityTree")) continue;

						if (props[i].name == "timeframe" && getProperty(element.viewers[v].prefs, "timeframe", "") == "static") continue;
						if ((props[i].name == "adgroup" || props[i].name == "adgroupname" || props[i].name == "aduser" || props[i].name == "adusername") && getProperty(element.viewers[v].prefs, "adgroup", "") == "static") continue;
						if (props[i].name == "entityUrl" && getProperty(element.viewers[v].prefs, "entityUrl", "static") == "static") continue;

						// handle visitor segments
						if (props[i].type == "multiple") {
							element.viewers[v].prefs = setPropertiesByName(element.viewers[v].prefs, props[i]);
						} else {
							element.viewers[v].prefs = setPropertyByName(element.viewers[v].prefs, props[i]);
						}

						if (props[i].name == "timeframe" && props[i].value != 0) {
							if (props[i].value.replace(/^[-]*/, "") == element.viewers[v].originalPrefs.timeframe.replace(/^[-]*/, "")) continue;

							var timeinterval = getRecommendedTimeInterval(props[i].value, element.viewers[v]);
							element.viewers[v].prefs = setPropertyByName(element.viewers[v].prefs, { name: "timeinterval", value: timeinterval });
						}
					}
				}
			}
			element.silent = false;
			refreshAll();
			element.silent = true;

			element.ignoreQuery = false;

			for (var i in element.viewers) {
				if (element.viewers[i] != null) {
					var showHelp = getProperty(element.viewers[i].prefs, "showhelp", "none");
					var showPreferences = getProperty(element.viewers[i].prefs, "showpreferences", "none");

					var box = findBox(element.viewers[i].type == "Meter" ? -1 : element.viewers[i].id);
					if (box) {
						box.toggleHelpIcon(showHelp, showPreferences, element.viewers[i].id, element.viewers[i].prefs); //(showHelp == "false" && showPreferences == "false") ? "none" : "show");
						updateLayers();
					}
				}
			}
		}
		function setPropertyByName(prefs, prop) {
			if (prop.action && prop.action == "delete") {
				// delete prefs
				var re = new RegExp("<" + prop.name + ">([^<]*)<\/" + prop.name + ">", "ig");
				if (prefs.match(re)) return prefs.replace(re, "");
				else return prefs;
			} else {
				// edit prefs
				var re = new RegExp("(<" + prop.name + ">)([^<]*)(<\/" + prop.name + ">)", "ig");
				// todo: handle static
				if (prefs.match(re)) return prefs.replace(re, "$1" + prop.value + "$3");
				else {
					// add prefs
					return prefs.replace(/(<\/prefs>)/i, "<" + prop.name.toUpperCase() + ">" + prop.value + "</" + prop.name.toUpperCase() + ">$1");
				}
			}
		}

		function setPropertiesByName(prefs, prop) {
			// set visitor segments in prefs
			// TODO: support pre-defined segments
			// TODO: Do not allow more then 4 segments in prefs
			var prefsName = "";
			switch (prop.name) {
				case "Goal":
				case "Goals":
					prefsName = "goals";
					break;
				case "Country":
				case "Countries":
					prefsName = "countries";
					break;
				case "Source":
				case "Medium":
				case "Term":
				case "Campaign":
				case "Content":
					prefsName = prop.name;
					break;
				default:
					prefsName = "categories";
					break;
			}

			if (prop.action && prop.action == "delete") {
				// delete prefs
				var re = new RegExp("<" + prefsName.toUpperCase() + ">([^<]*)<\/" + prefsName.toUpperCase() + ">", "ig");
				if (prefs.match(re)) return prefs.replace(re, "");
				else return prefs;
			} else {
				// edit prefs
				var re = new RegExp("(<" + prefsName.toUpperCase() + ">?)(.*)(<\/" + prefsName.toUpperCase() + ">)", "ig");
				if (prefs.match(re)) {
					// edit prefs
					switch (prefsName) {
						case "goals":
						case "countries":
							if (prop.value == "static") {
								//return prefs.replace(re, "");
								return prefs.replace(re, "$1" + prop.value + "$3");
							} else {
								return prefs.replace(re, "$1" + "<" + prop.name.toUpperCase() + " id=\"" + prop.id + "\">" + prop.value + "</" + prop.name.toUpperCase() + ">$3");
							}
							break;
						case "Source":
						case "Medium":
						case "Term":
						case "Campaign":
						case "Content":
							// if current value is "static" (no condition attribute)
							var re1 = new RegExp("(<" + prefsName.toUpperCase() + ")(>)(static)(<\/" + prefsName.toUpperCase() + ">)", "ig");
							if (prefs.match(re1)) {
								if (prop.value == "static") {
									return prefs; // do nothing
								} else {
									return prefs.replace(re1, "$1 c=\"" + prop.condition + "\">" + prop.value + "$4");
								}
							} else {
								if (prop.value == "static") {
									//return prefs.replace(re, "");
									return prefs.replace(re, "$1>" + prop.value + "$3");
								} else {
									return prefs.replace(re, "$1 c=\"" + prop.condition + "\">" + prop.value + "$3");
								}
							}
							break;
						default: // categories
							// if current value is "" (no categories defined)
							var re1 = new RegExp("(<" + prefsName.toUpperCase() + ">)(<\/" + prefsName.toUpperCase() + ">)", "ig");
							if (prefs.match(re1)) {
								if (prop.value == "" || prop.value == "static") {
									return prefs; // do nothing
								} else {
									if (prop.cid && prop.id) {
										return prefs.replace(re1, "$1" + "<CATEGORY id=\"" + prop.cid + "\" value=\"" + prop.id + "\">" + prop.value + "</CATEGORY>$2");
									}
									else {
										return prefs; // do nothing
									}
								}
							} else {
								if (prop.value == "" || prop.value == "static") {
									return prefs.replace(re, "$1$3");
								} else {
									if (prop.cid && prop.id) {
										return prefs.replace(re, "$1" + "<CATEGORY id=\"" + prop.cid + "\" value=\"" + prop.id + "\">" + prop.value + "</CATEGORY>$3");
									}
									else {
										return prefs.replace(re, "$1$3"); // do nothing
									}
								}
							}
							break;
					}
				} else {
					// add prefs
					switch (prefsName) {
						case "goals":
						case "countries":
							if (prop.value == "static")
								return prefs.replace(/(<\/prefs>)/i, "<" + prefsName.toUpperCase() + ">" + prop.value + "</" + prefsName.toUpperCase() + ">$1");
							else return prefs.replace(/(<\/prefs>)/i, "<" + prefsName.toUpperCase() + "><" + prop.name.toUpperCase() + " id=\"" + prop.id + "\">" + prop.value + "</" + prop.name.toUpperCase() + "></" + prefsName.toUpperCase() + ">$1");
							break;
						case "Source":
						case "Medium":
						case "Term":
						case "Campaign":
						case "Content":
							if (prop.value == "static")
								return prefs.replace(/(<\/prefs>)/i, "<" + prop.name.toUpperCase() + ">" + prop.value + "</" + prop.name.toUpperCase() + ">$1");
							else return prefs.replace(/(<\/prefs>)/i, "<" + prop.name.toUpperCase() + " c=\"" + prop.condition + "\">" + prop.value + "</" + prop.name.toUpperCase() + ">$1");
							break;
						default: // categories
							{
								if (prop.value != "static" || prop.value != "") {
									if (prop.cid && prop.id) {
										return prefs.replace(/(<\/prefs>)/i, "<" + prefsName.toUpperCase() + "><CATEGORY id=\"" + prop.cid + "\" value=\"" + prop.id + "\">" + prop.value + "</CATEGORY></" + prefsName.toUpperCase() + ">$1");
									}
									else {
										return prefs; // do nothing
									}
								}
								break;
							}
					}
				}
			}
		}

		function hasControls() {
			for (var i in element.viewers) {
				if (element.viewers[i] != null) return true;
			}
			return false;
		}

		function getPropertyByName(name, defaultValue, type) {
			var values = new Array();
			if (typeof (type) != "undefined" && type == "multiple") {
				// get visitor segments from prefs
				// TODO: support pre-defined segments
				for (var i in element.viewers) {
					if (element.viewers[i] != null) {
						prefs = element.viewers[i].prefs;
						switch (name) {
							case "Goal":
								var re = new RegExp("(^[^$]*<" + name + " )(id=[\"\']?)(.*)([\"\']?>)([^<]*)(<\/" + name + ">[^$]*$)", "i");

								if (prefs.match(re)) {
									id = prefs.replace(re, "$3");
									value = prefs.replace(re, "$5");
									values.push({ name: name, id: id, value: value.replace(/\&(?!amp;)/g, "&amp;") });
								} else {
									values.push({ name: "Goals", value: "static" });
								}
								break;
							case "Country":
								var re = new RegExp("(^[^$]*<" + name + " )(id=[\"\']?)([a-zA-Za]*)([\"\']?>)([^<]*)(<\/" + name + ">[^$]*$)", "i");

								if (prefs.match(re)) {
									id = prefs.replace(re, "$3");
									value = prefs.replace(re, "$5");
									values.push({ name: name, id: id, value: value.replace(/\&(?!amp;)/g, "&amp;") });
								} else {
									values.push({ name: "Countries", value: "static" });
								}
								break;
							case "Source":
							case "Medium":
							case "Term":
							case "Campaign":
							case "Content":
								var re = new RegExp("(^[^$]*<" + name + " )(c=[\"\']?)(.*)([\"\']?>)([^<]*)(<\/" + name + ">[^$]*$)", "i");
								if (prefs.match(re)) {
									condition = prefs.replace(re, "$3");
									value = prefs.replace(re, "$5");
									values.push({ name: name, condition: condition, value: value.replace(/\&(?!amp;)/g, "&amp;") });
								} else {
									values.push({ name: name, value: "static" });
								}
								break;
							default: // categories
								var re = new RegExp("(^[^$]*<category )(id=[\"\']?)([a-zA-Za0-9]*)([\"\']? value=[\"\']?([a-zA-Za0-9]*)[\"\']?>)([^<]*)(<\/category>[^$]*$)", "i");

								if (prefs.match(re)) {
									cid = prefs.replace(re, "$3");
									id = prefs.replace(re, "$5");
									value = prefs.replace(re, "$6");
									values.push({ name: name, cid: cid, id: id, value: value.replace(/\&(?!amp;)/g, "&amp;") });
								} else {
									values.push({ name: "categories", value: "static" });
								}
								break;
						}
					}
				}
			} else {
				defaultValue = (defaultValue) ? defaultValue : "";
				var values = new Array();
				for (var i in element.viewers) {
					if (element.viewers[i] != null) {
						values.push(getProperty(element.viewers[i].prefs, name, defaultValue));
					}
				}
			}
			return values;
		}
		function getProperty(prefs, name, defaultValue) {
			var value = defaultValue;
			var re = new RegExp("^[^$]*<" + name + ">([^<]*)<\/" + name + ">[^$]*$", "i");
			if (prefs.match(re)) value = prefs.replace(re, "$1");
			return value;
		}
		function setProperty(prefs, name, value) {
			var re = new RegExp("(^[^$]*<" + name + ">)([^<]*)(<\/" + name + ">[^$]*$)", "i");
			if (prefs.match(re)) {
				prefs = prefs.replace(re, "$1" + value + "$3");
			} else {
				prefs = prefs.replace(/<\/prefs/i, "<" + name + ">" + value + "</" + name + "></prefs");
			}
			return prefs;
		}

		function findBox(id) {
			var boxes = element.document.all["cardioLogBox"];
			if (boxes && boxes.length) {
				for (var i = 0; i < boxes.length; i++) {
					if (boxes[i]._id == id) return boxes[i];
				}
			} else if (boxes && boxes._id == id) return boxes;
		}

		function openPreferences(id, isMeter) {
			var box = findBox(isMeter ? -1 : id);
			if (box) box.openPreferencesWindow(isMeter ? id : null);
		}
		function refreshAll() {
			call(true, false, element.document.ReadOnly ? "temporary" : "save");
		}

		function setPrefs(viewerId, prefs) {
			// This function causes problems with unique users table
			//element.viewers[viewerId].prefs = prefs;
		}

		function setPreferences(id, prefs, meta, ignoreQuery, isMeter) {
			element.viewers[id].prefs = prefs;

			if (meta) element.viewers[id].meta = meta;
			if (ignoreQuery) {
				element.silent = true;
				element.ignoreQuery = true;
			} else {
				element.silent = false;
			}
			call(false, id, "save", prefs);

			element.ignoreQuery = false;
			var showHelp = getProperty(prefs, "showhelp", "none");
			var showPreferences = getProperty(prefs, "showpreferences", "none");

			var box = findBox(isMeter ? -1 : id);
			if (box) {
				box.toggleHelpIcon(showHelp, showPreferences, id, prefs); //(showHelp == "false" && showPreferences == "false") ? "none" : "show");
				updateLayers();
			}
		}

		function updateLayers() {
			element.document.updateLayers();
		}
		function redrawGraph(id) {
			if (element.viewers[id].obj)
				element.viewers[id].obj.resize();
		}

		function getExportOnce(id, prefs) {
			element.silent = false;
			Export(id, "temporary", prefs);
		}

		function getDataOnce(id, prefs, callback, meta, ignoreCache) {
			element.silent = false;
			element.viewers[id].temporaryCallback = callback;

			if (meta) element.viewers[id].meta = meta;
			else element.viewers[id].meta = element.viewers[id].defaultMeta;
			element.viewers[id].ignoreCache = (typeof (ignoreCache) == "undefined") ? false : ignoreCache;
			call(false, id, "temporary", (prefs) ? prefs : element.viewers[id].prefs);
			element.viewers[id].ignoreCache = false;
			// Added by Shay - getDataOnce is being used by the open dialog. 
			//  the meta should be used only for this call. 
			//  the original meta should be used in CLPage on the background
			element.viewers[id].meta = element.viewers[id].defaultMeta;
		}

		function getData(viewerId) {
			return element.viewers[viewerId].currentData;
		}

		function isWaiting() {
			return element.oncall || false;
		}

		function callSpecificViewer(id, meta) {
			var ids = new Array();
			if (id == -1) {
				for (var i in element.viewers) {
					if (element.viewers[i] != null && element.viewers[i].type == "Meter") ids[element.viewers[i].id] = element.viewers[i].id;
				}
			} else ids[id] = id;

			this.silent = false;
			if (meta) {
				for (var i in ids) {
					element.viewers[i].meta = meta;
				}
			}
			for (var i in ids) if (element.viewers[i]) element.viewers[i].ignoreCache = true;
			call(false, ids);
			for (var i in ids) if (element.viewers[i]) element.viewers[i].ignoreCache = false;
		}

		function refresh() {
			var currentIgnoreCache = element.document.alwaysIgnoreCache;
			element.document.alwaysIgnoreCache = true;
			call(true, false);
			element.document.alwaysIgnoreCache = currentIgnoreCache;
		}

		function schedule(now) {
			if (element.schedulerInterval) window.clearTimeout(schedulerInterval);
			var nextCall = 86400000;
			for (var i in element.viewers) {
				if (element.viewers[i] != null) {
					var viewerNextCall = new Date(element.viewers[i].lastCall);
					viewerNextCall.setSeconds(element.viewers[i].lastCall.getSeconds() + element.viewers[i].freq);
					if ((viewerNextCall - new Date()) < nextCall) {
						nextCall = viewerNextCall - new Date();
					}
				}
			}
			if (nextCall < 100000) nextCall = 100000;
			print("next call should be in " + nextCall + " ms");
			if (!element.document.Managed && !now) return;

			if (now) element.schedulerInterval = window.setTimeout(function () { call(now, false); }, (now) ? 0 : nextCall);

		}

		element.silent = false;

		function Export(specificViewer, action, tempPrefs) {
			var postString = "<calls>";

			if (action) {
				var currViewer = element.viewers[specificViewer];
				postString += "<call action='" + action + "' controlType='" + currViewer.type + "' controlId='" + currViewer.id + "'>" + tempPrefs.replace(/<([\/]*)([A-Z]*)/g, function (a, b, c) { return "<" + b + c.toLowerCase(); }) + "</call>";
				title = element.viewers[specificViewer].obj.getTitle();
				//				postString += "<call action='"+action+"' controlType='"+currViewer.type+"' controlId='"+currViewer.id+"' width='"+currViewer.width+"' height='"+currViewer.height+"'>"+tempPrefs.replace(/<([\/]*)([A-Z]*)/g, function (a, b, c) { return "<"+b+c.toLowerCase(); })+"</call>";
			} else {
				var title = this.element.document.ReportTitle; //(parent) ? parent.getCaption().replace(/ > /g, "-") : "";
				for (var i in element.viewers) {
					if (element.viewers[i] != null) {
						if (!specificViewer || specificViewer == i) {
							//if (element.viewers[i].type == "Meter" || element.viewers[i].type == "Details") continue;
							if (element.viewers[i].type == "Details") continue;
							postString += "<call controlType='" + element.viewers[i].type + "' controlId='" + element.viewers[i].id + "'>" + element.viewers[i].prefs.replace(/([0-9a-zא-ת]+)=([0-9a-zא-ת]+)/gi, "$1='$2'").replace(/([0-9a-zא-ת ]+)=\"([0-9a-zא-ת ]+)\"/gi, "$1='$2'") + "</call>";
							postString = excludeURL(postString);
							if (specificViewer == i) title = element.viewers[i].obj.getTitle();
							//postString += "<call controlType='"+element.viewers[i].type+"' controlId='"+element.viewers[i].id+"' width='"+element.viewers[i].width+"' height='"+element.viewers[i].height+"'>"+element.viewers[i].prefs.replace(/([0-9a-z]+)=([0-9a-z]+)/gi, "$1='$2'").replace(/([0-9a-z ]+)=\"([0-9a-z ]+)\"/gi, "$1='$2'")+"</call>";
						}
					}
				}
			}
			postString += "</calls>";

			var pageDetails = "username=" + element.document.UserName + "&entityId=" + element.document.EntityId + "&treeType=" + element.document.TreeType;

			var form = document.createElement("form");
			form.method = "POST";
			form.action = "/CardioLog/data/export.aspx";
			form.target = "formFrame";
			document.body.appendChild(form);

			var input = document.createElement("input");
			input.type = "hidden";
			input.name = "xml";
			form.appendChild(input);
			input.value = postString;

			input = document.createElement("input");
			input.type = "hidden";
			input.name = "exportTitle";
			form.appendChild(input);
			input.value = title;

			input = document.createElement("input");
			input.type = "hidden";
			input.name = "username";
			form.appendChild(input);
			input.value = element.document.UserName;

			input = document.createElement("input");
			input.type = "hidden";
			input.name = "entityId";
			form.appendChild(input);
			input.value = element.document.EntityId;

			input = document.createElement("input");
			input.type = "hidden";
			input.name = "treeType";
			form.appendChild(input);
			input.value = element.document.TreeType;

			input = document.createElement("input");
			input.type = "hidden";
			input.name = "type";
			form.appendChild(input);
			input.value = "excel";

			print("<textarea style='width:100%; height:100px;'>" + postString + "</textarea>");

			form.submit();
		}

		function useDefault(viewer) {
			try {
				var foo = viewer.meta["from"];
				return false;
			} catch (e) {
				return true;
			}
		}

		function prepareMeta(viewer) {
			var meta = "";
			if (!viewer.meta) return meta;
			if (useDefault(viewer)) viewer.meta = viewer.defaultMeta;
			for (var i in viewer.meta) {
				meta += " " + i + "='" + viewer.meta[i] + "'";
			}
			return meta;
		}

		function call(all, specificViewer, action, tempPrefs) {
			if (typeof (specificViewer) == "string") {
				var sv = specificViewer;
				specificViewer = new Array();
				specificViewer[sv] = sv;
			}
			if (!silent) {
				if (element.pleaseWaitMessage) element.pleaseWaitMessage.close();
				element.pleaseWaitMessage = createPleaseWaitMessage();
				element.silent = true;
			}

			var metaString = "";
			var postString = "<calls>";

			if (action) {
				if (all) {
					for (var i in element.viewers) {
						if (element.viewers[i] != null) {
							metaString = prepareMeta(element.viewers[i]);
							postString += "<call action='" + action + "' ignoreCache='" + (element.document.alwaysIgnoreCache || element.viewers[i].ignoreCache) + "' controlType='" + element.viewers[i].type + "' controlId='" + element.viewers[i].id + "'" + metaString + ">" + element.viewers[i].prefs.replace(/<([\/]*)([A-Z]*)/g, function (a, b, c) { return "<" + b + c.toLowerCase(); }).replace(/([0-9a-zא-ת]+)=([0-9a-zא-ת]+)/gi, "$1='$2'").replace(/([0-9a-zא-ת ]+)=\"([0-9a-zא-ת ]+)\"/gi, "$1='$2'") + "</call>";
							postString = excludeURL(postString);
						}
					}
				} else {
					for (var i in specificViewer) {
						var currViewer = element.viewers[i];
						metaString = prepareMeta(currViewer);
						postString += "<call action='" + action + "' ignoreCache='" + (element.document.alwaysIgnoreCache || element.viewers[i].ignoreCache) + "' controlType='" + currViewer.type + "' controlId='" + currViewer.id + "'" + metaString + ">" + tempPrefs.replace(/<([\/]*)([A-Z]*)/g, function (a, b, c) { return "<" + b + c.toLowerCase(); }).replace(/([0-9a-zא-ת]+)=([0-9a-zא-ת]+)/gi, "$1='$2'").replace(/([0-9a-zא-ת ]+)=\"([0-9a-zא-ת ]+)\"/gi, "$1='$2'") + "</call>";
						postString = excludeURL(postString);
					}
				}
			} else {
				for (var i in element.viewers) {
					if (element.viewers[i] != null) {
						var nextCall = new Date(element.viewers[i].lastCall);
						nextCall.setSeconds(element.viewers[i].lastCall.getSeconds() + element.viewers[i].freq);
						if ((new Date() >= nextCall && element.viewers[i].call != "") || all || specificViewer[i] == i) {
							metaString = prepareMeta(element.viewers[i]);
							postString += "<call ignoreCache='" + (element.document.alwaysIgnoreCache || element.viewers[i].ignoreCache) + "' controlType='" + element.viewers[i].type + "' controlId='" + element.viewers[i].id + "'" + metaString + ">" + element.viewers[i].prefs.replace(/([0-9a-zא-ת]+)=([0-9a-zא-ת]+)/gi, "$1='$2'").replace(/([0-9a-zא-ת ]+)=\"([0-9a-zא-ת ]+)\"/gi, "$1='$2'") + "</call>";
							postString = excludeURL(postString);
						}
					}
				}
			}
			postString += "</calls>";

			//prompt("", postString);
			var pageDetails = ((element.document.hideErrorInControls) ? "hideError=true&" : "") + ((element.document.RequestDebugMode) ? "debugMode=true&" : "") + "username=" + element.document.UserName + "&entityId=" + element.document.EntityId + "&treeType=" + element.document.TreeType;
			//postString = removeApos(postString);
			if (method == "GET") {
				print("<textarea style='width:100%; height:100px;'>" + postString + "</textarea>");
				//print(path+"?"+pageDetails+"&xml="+escape(postString)+((element.constantsParamString) ? "&"+constantsParamString : "")+((ignoreQuery) ? "&ignoreQuery=true" : ""));
				print(path + "?" + pageDetails + "&xml=" + encodeURIComponent(postString) + ((element.constantsParamString) ? "&" + constantsParamString : "") + ((ignoreQuery) ? "&ignoreQuery=true" : ""));
				var xml = getTransport();
				xml.Open("GET", path + "?" + pageDetails + "&xml=" + encodeURIComponent(postString) + ((element.constantsParamString) ? "&" + constantsParamString : "") + ((ignoreQuery) ? "&ignoreQuery=true" : ""), true);
				element.oncall = true;
				xml.onreadystatechange = function () { parseData(xml) };
				xml.Send();
			} else {
				print("POST!");
				print("<textarea style='width:100%; height:100px;'>" + postString + "</textarea>");
				print(path + "?" + pageDetails + "&xml=" + encodeURIComponent(postString) + ((element.constantsParamString) ? "&" + constantsParamString : "") + ((ignoreQuery) ? "&ignoreQuery=true" : ""));
				var xml = getTransport();
				xml.Open("POST", path, true);
				element.oncall = true;
				xml.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
				xml.onreadystatechange = function () { parseData(xml); };
				xml.Send(pageDetails + "&xml=" + encodeURIComponent(postString) + ((element.constantsParamString) ? "&" + constantsParamString : "") + ((ignoreQuery) ? "&ignoreQuery=true" : ""));
			}
		}

		function removeApos(value) {
			return value.replace(new RegExp("'", 'g'), "");
		}

		function createErrorMessage(message) {
			return window.showModelessDialog(element.htmlPath + "/CLPage/schedulerError.aspx", { scheduler: element, message: message }, "dialogHeight:200px; dialogWidth:350px; help:no; status:no;");
		}

		function closePleaseWaitMessage() {
			try {
				element.pleaseWaitMessage.popup.finish();
			} catch (e) {
				try {
					element.pleaseWaitMessage.close();
				} catch (e) {
				}
			}
		}

		function createPleaseWaitMessage() {
			closePleaseWaitMessage();
			var myJSONObject =
			{
				"popupArguments":
				[
				 { href: element.htmlPath + "/CLPage/schedulerLoading.aspx", scheduler: element, "dialogHeight": "120", "dialogWidth": "393px", "help": "no", "status": "no" }
				]
			};
			try {
				return parent.showPopup1(element.htmlPath + "/CLPage/schedulerLoading.aspx", 120, 393, myJSONObject, true);
			} catch (e) { return false; }
		}

		element.viewers = new Array();

		//function Viewer(id, prefs, freq, callback, type, obj, meta, width, height) {
		function Viewer(id, prefs, freq, callback, type, obj, meta) {
			this.id = id;
			this.prefs = prefs;
			this.freq = freq;
			this.callback = callback;
			this.lastCall = new Date();
			this.type = type;
			this.obj = obj;
			this.meta = meta;
			this.defaultMeta = meta;

			//this.width = (width) ? width : 0;
			//this.height = (height) ? height : 0;

			this.currentData = false;
		}

		function print(value) {
			element.document.Status.print(value);
		}

		function setDebugMode(debugMode) {
			document.all["debug"].style.display = (debugMode) ? "" : "none";
		}

		element.cancelConnection = function () {
			closePleaseWaitMessage();
			var img = document.createElement("img");
			img.style.display = "none";
			img.src = "/CardioLogAPI/CancelConnection.aspx?sid=" + element.document.SessionId + "&r=" + Math.random() * 100000;
			document.body.appendChild(img);
			//			print("/CardioLog/Data/CancelConnection.aspx");
			//			var xml = getTransport();
			//			xml.Open("GET", "/CardioLog/Data/CancelConnection.aspx", true);
			//			xml.Send();
			//			xml = null;
		}
	</script>
</head>
<body style="border:0px;">
	<div id="debug" style="font-family:Arial; font-size:11px; width:100%; height:200px; overflow:auto; display:none;"></div>
</body>
</html>