﻿<%@ OutputCache Duration="864000" VaryByHeader="Host" VaryByParam="none" Location="any"%>
<%@ Page language="JScript" %>
<%@ Import Namespace="CardioLog.API" %>
<%
	Response.ContentType = "text/x-component";
%>
<html xmlns:v="urn:schemas-microsoft-com:vml" xmlns:CARDIOLOG>
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8">
	<PUBLIC:COMPONENT tagName=TREE>
		<PUBLIC:ATTACH event="oncontentready" onevent="init()"/>
		
		<PUBLIC:METHOD name="updateBranches"></PUBLIC:METHOD>
		<PUBLIC:METHOD name="unselect"></PUBLIC:METHOD>
		<PUBLIC:METHOD name="selectNode"></PUBLIC:METHOD>
		<PUBLIC:METHOD name="setAsManaged"></PUBLIC:METHOD>
		<PUBLIC:METHOD name="setAsUnmanaged"></PUBLIC:METHOD>
		
		<PUBLIC:METHOD name="syncEntry"></PUBLIC:METHOD>
	</PUBLIC:COMPONENT>
	<style>
		.entryText	{ font-family: Tahoma, Arial;
									font-size: 12px;
									color: #003399; 
									cursor: hand; }
		.entryDeleted {	color: #CB5C5C; }
		.entry		{		padding:4px; }
	</style>
	<script src="/CardioLog/Scripts/Cookies.js"></script>
	<script language="JScript">
		element.rs = "";
		element.debugMode = "0";
		element.rightClick;
		
		function setAsManaged(id) {
			document.all["__item"+id].innerText = document.all["__item"+id].item.name+"*";
		}
		
		function setAsUnmanaged(id) {
			document.all["__item"+id].innerText = document.all["__item"+id].item.name;
		}
		
		function selectNode(id) {
			if (document.all["__item"+id]) {
				selectItem(document.all["__item"+id]);
				document.all["__item"+id].scrollIntoView(false);
			}
		}
		
		function unselect() {
			if (element.selectedItem && parent.getCaption().replace(/^[^$]*> ([^$]*)$/, "$1") != element.selectedItem.name) {
				element.selectedItem.span.style.background = "";
				element.selectedItem.span.style.color = "";
			}
		}
		
		function init() {
			defaults.viewLink = document;
			defaults.viewInheritStyle = false;
		
			this.sorted = (element.sorted == "true") ? true : false;
			
			this.rightClick = (element.rightClick == "false") ? false : true;
		
			showDeleted = (readCookie("showDeleted") == null) ? false : true;
			this.loadExpandedEntries();
			this.buildTree();
		}

		element.expandedEntries = new Array();
		element.idsToLoad = new Array();
		
		function addExpand(id) {
			element.expandedEntries[id] = true;
			saveExpandedEntries();
		}
		function removeExpand(id) {
			element.expandedEntries[id] = false;
			saveExpandedEntries();
		}
		function syncEntry(entries, autoopen) {
			element.autoopen = autoopen;
			element.idToSelect = entries[entries.length-1];

			var lastExpanded = -1;
			for (var i=0;i<entries.length;i++) {
				if (!element.expandedEntries[entries[i]] && typeof(document.all["children_"+entries[i]].numOfChildren) != "undefined" && (!document.all["children_"+entries[i]] || !document.all["children_"+entries[i]].loaded)) {
						lastExpanded = i;
						break;
				}
			}

			if (lastExpanded == -1) {
				for (var i=0;i<entries.length;i++) {
					if (!element.expandedEntries[entries[i]]) {
						document.all["toggleChildrenDiv_"+entries[i]].fireEvent("onclick");
					}
				}
				selectNode(entries[entries.length-1]);
				if (autoopen && document.all["__item"+entries[entries.length-1]]) document.all["__item"+entries[entries.length-1]].fireEvent("onclick");
			} else {
				for (var i=entries.length-1;i>=0;i--) {
					if (i > lastExpanded) addExpand(entries[i]);
					else if (!element.expandedEntries[entries[i]]) {
						document.all["toggleChildrenDiv_"+entries[i]].fireEvent("onclick");
					}
				}
//				document.all["toggleChildrenDiv_"+entries[lastExpanded]].fireEvent("onclick");
			}
		}
		function saveExpandedEntries() {
			var expandedString = "";
			for (var i in element.expandedEntries) {
				if (element.expandedEntries[i]) {
					expandedString += ((expandedString != "") ? "," : "")+i;
				}
			}
			saveCookie(element.type+"expanded", expandedString, 1000);
		}
		function loadExpandedEntries() {
			var expandedString = readCookie(element.type+"expanded");
			if (expandedString == null) return;
			var expandedArray = readCookie(element.type+"expanded").split(",");
			for (var i=0;i<expandedArray.length;i++) {
				element.expandedEntries[expandedArray[i]] = true;
			}
		}	

		function buildTree() {
			var xmlObj = new ActiveXObject("Msxml.DOMDocument");
			xmlObj.async = false;
			xmlObj.loadXML(this.innerHTML);
			if (xmlObj.parseError.errorCode != 0) {
				alert(xmlObj.parseError.reason);
			} else {
				drawEntry(xmlObj, 0, document.all["treeDiv"]);
				handleIdsToLoad();
			}
			xmlObj = null;
			//prompt("", element.rs);
		}
		
		var showDeleted = false;
		
		function drawEntry(entry, level, parentObj) {
			var entries = new Array();
			var numOfChildren = 0;

			if (entry.selectSingleNode("ITEMS")) {
				entries = entry.selectNodes("ITEMS/ITEM");
				if (entries.length > 0) {
					
					for (var i=0;i<entries.length;i++) {
						var deleted = entries[i].getAttribute("deleted");
						if (deleted != "True") numOfChildren += 1;
					}
					
				} else {
					if(showDeleted)
					numOfChildren = parseInt(entry.selectSingleNode("ITEMS").getAttribute(((showDeleted) ? "total" : "children")), 10);
				}
			}
			
			var div, span, nobr, img, childrenDiv = false;

			if (entry.tagName == "ITEM") {
				var text = entry.selectSingleNode("NAME").text;
				var id = entry.selectSingleNode("ID").text;
				var url = entry.selectSingleNode("URL").text;
				var type = entry.selectSingleNode("TYPE").text;
				var managed = entry.getAttribute("managed");
				var deleted = entry.getAttribute("deleted");
				if (deleted != null && deleted == "True" && !showDeleted) return;
				var path = (entry.selectSingleNode("PATH") != null) ? entry.selectSingleNode("PATH").text : "";
				var permissions = (entry.selectSingleNode("PERMISSION") != null) ? {add:((entry.selectSingleNode("PERMISSION").getAttribute("insert") != null && entry.selectSingleNode("PERMISSION").getAttribute("insert") == "True") ? true : false),
																																						modify:((entry.selectSingleNode("PERMISSION").getAttribute("update") != null && entry.selectSingleNode("PERMISSION").getAttribute("update") == "True") ? true : false),
																																						remove:((entry.selectSingleNode("PERMISSION").getAttribute("delete") != null && entry.selectSingleNode("PERMISSION").getAttribute("delete") == "True") ? true : false)} : {add:true, modify:true, remove:true};
				//element.rs += "'"+url+"',\n";
				
				div = document.createElement("div");
				div.className = "entry";
				div.id = id;
				div.permissions = permissions;
				div.style.paddingLeft = 20*(level-1);

				nobr = document.createElement("nobr");
				div.appendChild(nobr);
				
					img = document.createElement("img");
					img.id = "toggleChildrenDiv_"+id;
					img.style.height = "11px";
					img.style.width = "11px";
					if (numOfChildren > 0) {
						img._id = id;
						img.style.cursor = "hand";
						img.onclick = function() {
							this.src = this.src.match(/expand.gif/) ? this.src.replace(/expand/, "collapse") : this.src.replace(/collapse/, "expand");
							document.all["children_"+this._id].style.display = (document.all["children_"+this._id].style.display == "none") ? "" : "none";
							if (document.all["children_"+this._id].children.length > 0) {
								if (document.all["children_"+this._id].children(0).id == "pleaseWait") {
									getData(this._id);
								}
								if (this.src.match(/collapse.gif/)) {
									addExpand(this._id);
								} else {
									removeExpand(this._id);
								}
							} else {
								this.src = element.imagesPath+"empty.gif";
							}
						}

						img.src = element.imagesPath+((element.expandedEntries[id]) ? "collapse.gif" : "expand.gif");
						childrenDiv = document.createElement("div");
						childrenDiv.style.display = (element.expandedEntries[id]) ? "" : "none";
						childrenDiv.id = "children_"+id;
						childrenDiv.numOfChildren = numOfChildren;
						childrenDiv.loaded = (entries.length == numOfChildren) ? true : false;
						childrenDiv.level = level;
						childrenDiv._id = id;
						childrenDiv.path = ((parentObj.path) ? parentObj.path+" > " : "")+handleHebrew(getPath(entry));
					} else {
						img.src = element.imagesPath+"empty.gif";
//						if (type == "Folder") {
							childrenDiv = document.createElement("div");
							childrenDiv.style.display = (element.expandedEntries[id]) ? "" : "";
							childrenDiv.id = "children_"+id;
							childrenDiv.level = level;
							childrenDiv.path = ((parentObj.path) ? parentObj.path+" > " : "")+handleHebrew(getPath(entry));
//						}
					}
					img.align = "absmiddle";
					nobr.appendChild(img);

					span = document.createElement("span");
					span.className = "entryText";
					span.innerText = " ";
					nobr.appendChild(span);
					
					img = document.createElement("img");
					if(type != "ts")
					{
					    img.style.width = "16px";
					    img.style.height = "16px";
					}
					img.defaultSrc = entry.selectSingleNode("TYPE").text;
					img.onerror = function() {
						this.src = element.imagesPath+"GenericList.gif";
					}
					img.src = element.imagesPath+((entry.selectSingleNode("TYPE").text == "") ? "GenericList" : entry.selectSingleNode("TYPE").text)+".gif";
					img.align = "absmiddle";
					img.title = img.src;

					img.item = {id:entry.selectSingleNode("ID").text, type:entry.selectSingleNode("BASETYPE").text, name:entry.selectSingleNode("NAME").text, url:entry.selectSingleNode("URL").text, path:"", permissions:permissions, parentId:parentObj._id};
					img.oncontextmenu = contextmenu;
					nobr.appendChild(img);

					span = document.createElement("span");
					span.className = "entryText";
					span.innerText = " ";
					nobr.appendChild(span);
					
					span = document.createElement("span");
					span.id = "__item"+entry.selectSingleNode("ID").text;
					if (deleted != null && deleted == "True") span.className = "entryText entryDeleted";
					else span.className = "entryText";
					
					span.item = {id:entry.selectSingleNode("ID").text, type:entry.selectSingleNode("BASETYPE").text, name:entry.selectSingleNode("NAME").text, url:entry.selectSingleNode("URL").text, path:"", permissions:permissions, parentId:parentObj._id};
					span.onmouseover = function() {
						this.style.textDecoration = "underline";
					}
					span.onmouseout = function() {
						this.style.textDecoration = "none";
					}
					if (element.rightClick) {
						span.oncontextmenu = contextmenu;
					}
					span.onclick = function() {
						selectItem(this);
						eval("element.document."+element.callback+"()");
					}
					span.ondblclick = function() {
						selectItem(this);
						if (element.dblcallback) eval("element.document."+element.dblcallback+"()");
					}
					span.innerText = text+((managed) ? "*" : "")+((element.showNumOfChildren && numOfChildren > 0) ? "\u200E ("+numOfChildren+")" : "");
					span.title = (path != "") ? path : ((url.replace(/ /g,"") != "") ? url : "");
					nobr.appendChild(span);
					span.item.path = ((parentObj.path) ? parentObj.path+" > " : "")+handleHebrew(getPath(entry));

				parentObj.appendChild(div);
				if (childrenDiv) parentObj.appendChild(childrenDiv);

				div = null;
				span = null;
				nobr = null;
				img = null;
			}
			
			function contextmenu() {
				event.returnValue = false;
				event.cancelBubble = true;
				var obj = (this.tagName == "IMG") ? this.parentElement.children[this.parentElement.children.length-1]: this;
				selectItem(obj);

				if (element.rccallbackpre) {
					try {
						eval("element.document."+element.rccallbackpre+"()");
					} catch (e) {
					}
				}
				try {
					element.document.entryMenu.show(obj, eval("element.document."+element.callback), event);
				} catch (e) {
				}
				return false;
			}

			function getPath(entry) {
				return entry.selectSingleNode("NAME").text;
			}

			if (numOfChildren > 0) {
				if (entries.length > 0) {
					if (element.sorted) {
						var entriesArray = new Array();
						for (var i=0;i<entries.length;i++) {
							entriesArray.push({name:entries[i].selectSingleNode("NAME").text, xml:entries[i]});
						}
						function compare(a, b) {
							if (a.name >= b.name) return 1;
							else return -1;
						}
						var entriesSorted = entriesArray.sort(compare);
						for (var i=0;i<entriesSorted.length;i++) {
							drawEntry(entriesSorted[i].xml, level+1, (childrenDiv) ? childrenDiv : parentObj);
						}
					} else {
						for (var i=0;i<entries.length;i++) {
							drawEntry(entries[i], level+1, (childrenDiv) ? childrenDiv : parentObj);
						}
					}
				} else {
					if (childrenDiv.style.display == "") {
						element.idsToLoad[element.idsToLoad.length] = id;
					}
					childrenDiv.appendChild(getPleaseWait(level), id);
				}
			}
		}

		function handleHebrew(value) {
			if (value.match(/[א-ת]/)) {
				return "\u200E "+value+"";
			}
			else return value;
		}
		
		function selectItem(obj) {
			if (typeof(obj) == "undefined") return;
			if (element.selectedItem) {
				element.selectedItem.span.style.background = "";
				element.selectedItem.span.style.color = "";
			}
			obj.item.span = obj;
			element.selectedItem = obj.item;
			obj.style.background = "#3E70C6";
			obj.style.color = "white";
		}
		
		function getPleaseWait(level, id) {
			var nobr;
			var div;
			var img;
			var span;
			
			div = document.createElement("div");
			div.id = "pleaseWait";
			div.className = "entry";
			div.style.paddingLeft = 20*(level);

			nobr = document.createElement("nobr");
			div.appendChild(nobr);
			
				img = document.createElement("img");
				img.src = element.imagesPath+"empty.gif";
				img.align = "absmiddle";
				nobr.appendChild(img);

				span = document.createElement("span");
				span.innerText = " ";
				nobr.appendChild(span);
				
				img = document.createElement("img");
				img.src = element.imagesPath+"wait.gif";
				img.align = "absmiddle";
				nobr.appendChild(img);

				span = document.createElement("span");
				span.innerText = " ";
				nobr.appendChild(span);
				
				span = document.createElement("span");
				span.className = "entryText";
				span.style.cursor = "default";
				span.innerText = "<%=CardioLog.API.Localization.getText("$Please wait$")%>...";
				nobr.appendChild(span);
				
			nobr = null;
			img = null;
			span = null;
			return div;
		}

		function drawBranch(entry) {
			var id = entry.getAttribute("id");
			
			removeIdFromPending(id);
			//alert(id+"\n"+element.idsToLoad.join(","));
			
			var selectedChild = false;
			var childrenDiv = document.all["children_"+id];
			if (!childrenDiv) return;
			childrenDiv.loaded = true;
			for (var i=childrenDiv.children.length-1;i>=0;i--) childrenDiv.children(i).removeNode(true);
			var entries = entry.selectNodes("ITEM");
			for (var i=0;i<entries.length;i++) {
				if (entries[i].getAttribute("selected") != null) selectedChild = entries[i];
				drawEntry(entries[i], childrenDiv.level+1, childrenDiv);
			}
			// handle toggle icon
			var img = document.all["toggleChildrenDiv_"+id];
			if (img.src.match(/empty.gif/)) {
				img._id = id;
				img.style.cursor = "hand";
				img.onclick = function() {
					this.src = this.src.match(/expand.gif/) ? this.src.replace(/expand/, "collapse") : this.src.replace(/collapse/, "expand");
					document.all["children_"+this._id].style.display = (document.all["children_"+this._id].style.display == "none") ? "" : "none";
					if (document.all["children_"+this._id].children.length > 0) {
						if (document.all["children_"+this._id].children(0).id == "pleaseWait") {
							getData(this._id);
						}
						if (this.src.match(/collapse.gif/)) {
							addExpand(this._id);
						} else {
							removeExpand(this._id);
						}
					} else {
						this.src = element.imagesPath+"empty.gif";
					}
				}
				document.all["children_"+id].style.display = "";
				document.all["children_"+id].loaded = true;
				img.src = element.imagesPath+"collapse.gif";
			}
			handleIdsToLoad();
			
			return selectedChild;
		}	
		
		function removeIdFromPending(id) {
			if (element.idsToLoad.length > 0) {
				var removePosition = -1;
				for (var i=0;i<element.idsToLoad.length;i++) {
					if (element.idsToLoad[i] == id) {
						removePosition = i;
						break;
					}
				}			
				for (var i=removePosition;i<element.idsToLoad.length-1;i++) {
					element.idsToLoad[i] = element.idsToLoad[i+1];
				}
				element.idsToLoad.length -= 1;
			}
		}
		
		function handleIdsToLoad() {
			var ids = "";
			for (var i=0;i<element.idsToLoad.length;i++) ids += ((ids == "") ? "" : ",")+element.idsToLoad[i];
			if (ids != "") getData(ids);
			element.idsToLoad = new Array();
		}
			
		function updateBranches(node, selectParent, ignoreSelection) {
				var entries = node.selectNodes("TREE/ITEMS");
				var selected = false;
				var parentId = false;
				
				for (var i=0;i<entries.length;i++) {
					var currSelected = drawBranch(entries[i]);
					if (currSelected) selected = currSelected;
					parentId = entries[i].getAttribute("id");
				}

				// check if should automatically select an entry
				if (selected && !ignoreSelection) {
					selectItem(document.all["__item"+selected.selectSingleNode("ID").text]);
					eval("element.document."+element.callback+"()");
				} else if (selectParent) {
					selectItem(document.all["__item"+parentId]);
					eval("element.document."+element.callback+"()");
				}
		}

		function getData(id) {
			if (!element.document.Ajax) {
				element.document.Status.print("Client does not support Ajax capabilities. Please contact your system administrator.");
				return;
			}
			function callback(status) {
				if (status.errorCode != 0) alert(status.reason);
				else {
					var entries = status.ResponseXml.selectNodes("TREE/ITEMS");
					for (var i=0;i<entries.length;i++) {
						drawBranch(entries[i]);
						if (element.idToSelect && document.all[element.idToSelect]) {
							selectNode(element.idToSelect);
							if (element.autoopen && document.all["__item"+element.idToSelect]) document.all["__item"+element.idToSelect].fireEvent("onclick");
							element.idToSelect = false;
						}
					}
				}
			}
			element.document.Status.print("calling from "+element.id+" with id "+id);
			// todo: make sure only calls from this instance are coming back to the callback
			if (element.document.TreeManager) 
				element.document.TreeManager.Request(element.id, "GET", element.source, "id="+id+"&r="+Math.random(), true, false, callback);
			else
				element.document.Ajax.Request("GET", element.source, "id="+id+"&r="+Math.random(), true, false, callback);
		}
		
		window.attachEvent("onunload", dispose);
		function dispose() {
			var imgs = document.getElementsByTagName("img");
			for (var i=imgs.length-1;i>=0;i--) imgs[i].removeNode(true);

			var spans = document.getElementsByTagName("span");
			for (var i=spans.length-1;i>=0;i--) spans[i].removeNode(true);

			var divs = document.getElementsByTagName("div");
			for (var i=divs.length-1;i>=0;i--) divs[i].removeNode(true);
			
			
		}
	</script>
</head>
<body style="border:0px;">
	<div id="treeDiv"></div>
</body>
</html>