//SPS2010
var __alreadyinitiated = false;
var __alreadyloaded = false;

function __initEnvironmentAgent()
{
    if (__alreadyinitiated) return;
    __alreadyinitiated = true;
}

function __initSP2010Agent() {
    if (__alreadyloaded) return;
    __alreadyloaded = true;

    if (__Page.readyState != "error") {
        // support additional data to view events in param3
        if (element.Param3ElementName) {
        	__aeLogger.trace("Param3ElementName is on");
            __Page.param3 = GetParam3ElementValue();
            __aeLogger.trace("__Page.param3: " + __Page.param3);
        }

        // set agent handler
        __Page.agent = "SP2010Agent";

        // handle exceptions (TOCHECK)
        __Page.customShouldContinue = __SP2010ShouldContinue;

        // populate Agent Object Model
        __Page.customInit = __SP2010CreateAOM;

        // set supported events by this agent
        __Page.events = { Visit: true, Leave: true, Search: true, SearchResultItem: true, SearchResultClick: true };

        // overwrite the event detection
        __EventHandler.New = __SP2010EventNew;

        // catch customready if special actions are needed based on custom values
        __Page.attachEvent("customready", __SP2010CreateCustom);

        __Page.init();

        if (__Page.readyState == "ready") __Page.sendEvent(__SP2010NewVisit(), false, false);
    } else {
        window.status = "Error loading SP2010Agent: " + __Page.errorDescription;
        if (typeof (__Status) != "undefined") __Status.print("Error loading SP2010Agent: " + __Page.errorDescription);
        else __Status = { output: new Array({ o: "Error loading SP2010Agent: " + __Page.errorDescription }) };
    }
}

function __SP2010EventNew(e) {
	__aeLogger.trace("__SP2010EventNew");
    var event = new __Event(e);
    __aeLogger.trace("__SP2010EventNew return: " + (event != null ? event.ToString() : "null"));
    return event;
}

function __SP2010NewVisit() {
	__aeLogger.trace("__SP2010NewVisit");
    var event = __EventHandler.NewVisit();
    __aeLogger.trace("__SP2010NewVisit return: " + (event != null ? event.ToString() : "null"));
    return event;
}

function __SP2010ShouldContinue() {
    return "ready";
}

function isSearchPage() {
    var divs = document.getElementsByTagName("div");
    for (var i = 0; i < divs.length; i++) {
        if (divs[i].className == "srch-stats" || (/srch-sort-right/g).test(divs[i].className)) {
            return true;
        }
    }
    return false;
}

function __SP2010CreateAOM() {
	__aeLogger.trace("SP2010");
    __eTypes = { Page: 0, Search: 0 };
    __eEvents = {
        Visit: { id: 0, name: "Visit" },
        Leave: { id: 1, name: "Leave" },
        Search: { id: 2, name: "Search" },
        SearchResultItem: { id: 4, name: "SearchResultItem" },
        SearchResultClick: { id: 5, name: "SearchResultClick" },
        External: { id: 10, name: "External" },
        Goal: { id: 20, name: "Goal" },
        "Goal-Test": { id: 21, name: "Goal-Test" },
        Test: { id: 22, name: "Test" },
        Score: { id: 23, name: "Score" },
        Ping: { id: 24, name: "Ping" },
        Unknown: { id: -1, name: "Unknown" }
    };
    this.url = this.document.location.href;
    try {
        if (isSearchPage()) {
            this.Search.readyState = "ready";
            this.entityType = __eTypes.Search;
            this.eventType = __eEvents.Search;
            this.fireEvent("onsearch");
            // find search term
            var searchTermFromAdvanced = __Page.CookieHandler.Read("LastSearchTermFromAdvanced");
            var inputs = this.document.getElementsByTagName("input");
            var searchInput = false;
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].id.match(/InputKeywords$/i)) {
                    searchInput = inputs[i];
                    break;
                }
            }
            if (searchInput) {
                this.Search.Keyword = (searchInput.value.replace(/ /g) == "") ? searchTermFromAdvanced : encodeURIComponent(searchInput.value);
                this.Search.Input = searchInput;
                // find out number of results
                var summaryBlock = this.document.getElementById("SRST");
                if (!summaryBlock) throw { description: "could not find SRST block" };
                this.Search.EntityId = "N/A";
                this.Search.NumberOfTotalResults = summaryBlock.innerHTML.replace(/^[^0-9]*[0-9]*-[0-9]*[^0-9]*([0-9,]*).*$/, "$1");
                if (this.Search.NumberOfTotalResults == summaryBlock.innerHTML) this.Search.NumberOfTotalResults = 0;
                else this.Search.NumberOfTotalResults = this.Search.NumberOfTotalResults.replace(/,/g, "");
                this.Search.FirstResultOnPage = parseInt(summaryBlock.innerHTML.replace(/^[^0-9,]*([0-9,]*).*$/, "$1"), 10);
                if (isNaN(this.Search.FirstResultOnPage)) this.Search.FirstResultOnPage = 1;
                // get search results
                var resultsDiv = this.document.getElementsByName("CSR");
                if (resultsDiv.length == 0) resultsDiv = new Array(document.getElementById("CSR"));
                var results;
                if (typeof (resultsDiv) != "undefined" && resultsDiv.length > 0) results = (resultsDiv.length > 1) ? resultsDiv[1].getElementsByTagName("DIV") : resultsDiv[0].getElementsByTagName("DIV");
                else results = new Array();
                for (var i = 0; i < results.length; i++) {
                    if (results[i].className == "srch-Title2") {
                        var currA = results[i].getElementsByTagName("a")[0];
                        if (currA) currA.__type = __eEvents.SearchResultItem;
                        this.Search.Results[this.Search.Results.length] = currA;
                    }
                }
				__EventHandler.searchResultPageHandler();
            } else {
                throw { description: "could not find search input" };
            }
        } else {
            this.eventType = __eEvents.Visit;
            this.fireEvent("onvisit");
            // check type of page
            this.entityType = __eTypes.Page;
        }
    } catch (e) { }
    this.fireEvent("onload");
}

function __SP2010CreateCustom() {
    // check if advanced, add keyword to cookie
    var isAdvanced = false;
    for (var i = 0; i < AdvancedSearchPages.length; i++) {
        var re = new RegExp(AdvancedSearchPages[i], "i");
        if (document.location.href.match(re)) {
            isAdvanced = true;
            __captureSearchTerm();
        }
    }
    if (!isAdvanced) {
        __Page.CookieHandler.Delete("LastSearchTermFromAdvanced");
    }
}

function __captureSearchTerm() {
    var inputs = document.getElementsByTagName("input");
    for (var i = 0; i < inputs.length; i++) {
        if (inputs[i].type == "submit") {
            if (inputs[i].attachEvent) {
                inputs[i].attachEvent("onclick", function () {
                    for (var i = 0; i < inputs.length; i++) {
                        if (inputs[i].type == "text" && inputs[i].value.replace(/ /g) != "") {
                            __Page.CookieHandler.Save("LastSearchTermFromAdvanced", inputs[i].value);
                            break;
                        }
                    }
                });
            } else {
                try {
                    inputs[i].addEventListener("click", function () {
                        for (var i = 0; i < inputs.length; i++) {
                            if (inputs[i].type == "text" && inputs[i].value.replace(/ /g) != "") {
                                __Page.CookieHandler.Save("LastSearchTermFromAdvanced", inputs[i].value);
                                break;
                            }
                        }
                    }, false);
                } catch (e) {
                }
            }
        }
    }
}
__initEnvironmentAgent();

// SP2010 FIXES <<--
// RIBBON BUG FIX (for SharePoint 2010 on Chrome only)
if (typeof _spBodyOnLoadWrapper !== 'undefined' && navigator.userAgent.match(/Chrome/)) {
	if (typeof _spBodyOnLoadCalled === 'undefined' || _spBodyOnLoadCalled == false) {
		_spBodyOnLoadWrapper();
	}
}

function noErrorMessages(err, url) {
    // HANDLE MAX THE POPUP ERROR
    if (err.search(/invalid argument/gi) >= 0 && url.search(/sp.ui.rte/gi) >= 0) {
        return true;
    }
    // HANDLES CLOSING THE POPUP
    else if (err.search(/or not an object/gi) >= 0 && url.search(/sp.ui.dialog/gi) >= 0) {
        return true;
    }
    return false;

}
window.onerror = noErrorMessages;

function normalizeSPUserAccount(userName) {
	if(userName == null)
		return "";
	return userName;
	
	// removed, user name can be fixed in server side
    //var splitedTokens = userName.split("|");
    //return splitedTokens[splitedTokens.length - 1].replace("&nbsp;", "");
}

//this function is used to retrieve user account for sharepoint online
function getSPUserAccount(callback) {
    if (typeof (_spPageContextInfo) != "undefined" && typeof (_spPageContextInfo.userId) == "undefined") {
        callback(null);
        return;
    }

    getSPUserAccountInternal(callback, 1);
}

function getSPUserAccountInternal(callback, iter) {
    if (typeof (SP.ClientContext) == "undefined") {
        if (iter < 10) {
            window.setTimeout(function () {
                getSPUserAccountInternal(callback, (iter + 1));
            }, 100);
        }
        else {
            getSPUserAccountFromUserDisp(callback);
        }
        return;
    }


    try{
		var ctx = SP.ClientContext.get_current();
		var usr = ctx.get_web().get_currentUser();
		ctx.load(usr);
		ctx.executeQueryAsync(Function.createDelegate(this, function () {
			//get_loginName
			var userName = null;
			userName = normalizeSPUserAccount(usr.get_loginName());

			callback(userName);
		}));
	}
	catch (ex) {
		__aeLogger.trace("Error when trying to access SP object. function getSPUserAccountInternal.");
		getSPUserAccountFromUserDisp(callback);
	}


    return;
}


//this function is used to retrieve user account for sharepoint online
function getSPUserAccountFromUserDisp(callback) {
    var url = window.location.protocol + "//" + window.location.host;

    if (typeof L_Menu_BaseUrl !== "undefined" && L_Menu_BaseUrl) { //2007
        url += L_Menu_BaseUrl == "" ? "/" : L_Menu_BaseUrl;
    }

    url += "/_layouts/userdisp.aspx?Force=True&d=" + new Date().getTime();

    var xmlhttp;
    if (window.XMLHttpRequest) { // code for IE7+, Firefox, Chrome, Opera, Safari
        xmlhttp = new XMLHttpRequest();
    } else { // code for IE6, IE5
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    }

    xmlhttp.onreadystatechange = function () {
        if (xmlhttp.readyState == 4 && xmlhttp.statusText == "OK") {
            var _current_user_name;
            try {
                var resHtml = xmlhttp.responseText.toLowerCase();

                var strToSearch = '<td valign="top" class="ms-formbody" width="350px" id="spfieldtext">';
                var pos = resHtml.indexOf(strToSearch);
                if (pos >= 0) {
                    var dispnamePropertiesHtml = resHtml.substring(resHtml.indexOf(strToSearch) + strToSearch.length, resHtml.length);
                    dispnamePropertiesHtml = dispnamePropertiesHtml.substring(0, dispnamePropertiesHtml.indexOf('</td>') - 5);
                    dispnamePropertiesHtml = dispnamePropertiesHtml.substring(dispnamePropertiesHtml.indexOf('-->') + 3, dispnamePropertiesHtml.length);
                    _current_user_name = normalizeSPUserAccount(dispnamePropertiesHtml.replace(/^\s+|\s+$/gm, ''));
                }
            } catch (ex) {
                __aeLogger.trace(ex.message);
            }

            if (!_current_user_name) {
                _current_user_name = "Anonymous_" + Math.random() * 100000;
            }

            callback(_current_user_name);
        }
    }

    xmlhttp.open("GET", url, true);
    xmlhttp.send();
}
